Subject: Re: DLSw : Flow Control

From: [email-masked] (Alan Bartky)
Date: Wed, 31 Jan 96 09:32:56 PST

To I. Leonardi and other Data Link Switchers -

In my response to G Sivakumar, I was doing a lot of it from
memory.  I received a question from I. Leonardi and went
back and looked at RFC1795.  My comments are edited in
below:

> From omni!synaptel.fr!leonardi Wed Jan 31 07:26:05 1996
> From: omni!synaptel.fr!leonardi
> Date: Wed, 31 Jan 1996 14:26:32
> Reply-To: omni!synaptel.fr!leonardi
> Subject: DLSw : Flow Control
> To: omni!alan
> Mime-Version: 1.0
> Content-Type> : > text/plain> ; > charset=us-ascii> 
> Content-Transfer-Encoding: 7Bit
> X-Mailer: <WinQVT/Net v3.9>
> Content-Length: 561
> 
> Alan,
> 
> I read the answer that you sent to Sivakumar G about Flow Control in DLSw 
> protocol and I don't understand why you said that there is no fixed pacing. I 
> didn't find where it is said in RFC1795. (In section 8, there is an example for 
> Fixed Pacing and another for Adaptive Pacing...) Moreover, I think that a fixed 
> pacing implementation can talk with an adaptive pacing one because a DLSw 
> partner can only say to the other what it is able to receive!
> Could you please tell me if I misunderstood something?
> 
> Regards,
> 
> I.Leonardi ([email-masked])
> 
>

After looking at the RFC again, you are correct that there are
examples of fixed and adaptive pacing.  You are also correct
that it is the receiver that controls the data flow (pacing).
And therefore a station that has implemented adaptive pacing
for its receive data should have no problem running with one
that has implemented fixed pacing for its receive data. 

Section 8.1 states:

   Each circuit consists of two data flows, one in each direction.  Each
   data flow has its own independent flow control mechanism.  For each
   data flow there is an entity that originates traffic, referred to as
   the sender, and a target entity which receives the traffic, referred
   to as the receiver.

   A sender may only send data when its receiver has granted explicit
   permission to send a discrete number of data units.  Data units are
   defined as either a DGRMFRAME or an INFOFRAME.

   The receiver grants permission to send data units by sending a Flow
   Control Indicator (FCIND- defined later).  The sender must
   acknowledge all FCINDs by sending a Flow Control Acknowledgment

My mistake was in confusing the question with whether or not
the question was if there was more than one protocol
to accomplish it.  We had had discussions during the meetings
and came to the conclusion that everyone wanted one protocol 
and did not want require support for enter/exit busy.

By having the receiver dictate the pacing, it can use the
procotol defined to either implement a fixed or adaptive
algorithm to do it.

And again before I get into any more trouble by responding
to the flow control section, if you have specific questions
(and if he doesn't mind answering them) Shannon Nix
was the hard worker who both chaired the Flow Control Working
Group and edited the section.  He would be the best person
to direct your questions to on DLSw Pacing.  His email address
is [email-masked]

Regards,

Alan

**********************************************************
Alan K. Bartky                       Email:[email-masked]
Principal Software Engineer
XYLAN Corporation                    Voice:(714) 597-8042
15707 ROCKFIELD BLVD STE 155F        FAX:  (714) 597-8342
IRVINE CA 92718-2830
**********************************************************